質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

87.34%

Ubuntuでのpip install mpi4pyができない

解決済

回答 2

投稿

  • 評価
  • クリップ 0
  • VIEW 5,165

score 12

 前提・実現したいこと

Bash on Ubuntu on Windows
Ubuntu 16.04.3 LTS
anaconda3-5.1.0
という環境で
pip install mpi4py
を実行したところ、下のようなメッセージが出ました。

このコマンドをエラーなく実行したいです。

最後の数行にエラーのまとめ的なものがあるのはわかるのですが、
ここから何をすればいいのかわかりません。

要するに
Building wheels for collected packages: mpi4py
ができていないことはわかりました。

 発生している問題・エラーメッセージ

username@DESKTOP-F7B6US2:~$ pip install mpi4py
Collecting mpi4py
  Downloading mpi4py-3.0.0.tar.gz (1.4MB)
    100% |████████████████████████████████| 1.4MB 1.0MB/s
Building wheels for collected packages: mpi4py
  Running setup.py bdist_wheel for mpi4py ... error
  Complete output from command /home/username/anaconda3/bin/python -u -c "import setuptools, tokenize;__file__='/tmp/pip-build-8zxw1o7r/mpi4py/setup.py';f=getattr(tokenize, 'open', open)(__file__);code=f.read().replace('\r\n', '\n');f.close();exec(compile(code, __file__, 'exec'))" bdist_wheel -d /tmp/tmpjqih1l9ipip-wheel- --python-tag cp36:
  running bdist_wheel

---------------------------------------------- 中略 ----------------------------------------------

  removing: _configtest.c _configtest.o _configtest
  building 'mpi4py.dl' extension
  gcc -pthread -B /home/username/anaconda3/compiler_compat -Wl,--sysroot=/ -Wsign-compare -DNDEBUG -g -fwrapv -O3 -Wall -Wstrict-prototypes -fPIC -DHAVE_DLFCN_H=1 -DHAVE_DLOPEN=1 -I/home/username/anaconda3/include/python3.6m -c src/dynload.c -o build/temp.linux-x86_64-3.6/src/dynload.o
  gcc -pthread -shared -B /home/username/anaconda3/compiler_compat -L/home/username/anaconda3/lib -Wl,-rpath=/home/username/anaconda3/lib -Wl,--no-as-needed -Wl,--sysroot=/ build/temp.linux-x86_64-3.6/src/dynload.o -Lbuild/temp.linux-x86_64-3.6 -ldl -o build/lib.linux-x86_64-3.6/mpi4py/dl.cpython-36m-x86_64-linux-gnu.so
  checking for MPI compile and link ...
  gcc -pthread -B /home/username/anaconda3/compiler_compat -Wl,--sysroot=/ -Wsign-compare -DNDEBUG -g -fwrapv -O3 -Wall -Wstrict-prototypes -fPIC -I/home/username/anaconda3/include/python3.6m -c _configtest.c -o _configtest.o
  _configtest.c:2:17: fatal error: mpi.h: No such file or directory
  compilation terminated.
  failure.
  removing: _configtest.c _configtest.o
  error: Cannot compile MPI programs. Check your configuration!!!

  ----------------------------------------
  Failed building wheel for mpi4py
  Running setup.py clean for mpi4py
Failed to build mpi4py
Installing collected packages: mpi4py
  Running setup.py install for mpi4py ... error
    Complete output from command /home/username/anaconda3/bin/python -u -c "import setuptools, tokenize;__file__='/tmp/pip-build-8zxw1o7r/mpi4py/setup.py';f=getattr(tokenize, 'open', open)(__file__);code=f.read().replace('\r\n', '\n');f.close();exec(compile(code, __file__, 'exec'))" install --record /tmp/pip-ublkswyp-record/install-record.txt --single-version-externally-managed --compile:

---------------------------------------------- 中略 ----------------------------------------------

    removing: _configtest.c _configtest.o _configtest
    checking for function 'dlopen' ...
    gcc -pthread -B /home/username/anaconda3/compiler_compat -Wl,--sysroot=/ -Wsign-compare -DNDEBUG -g -fwrapv -O3 -Wall -Wstrict-prototypes -fPIC -I/home/username/anaconda3/include/python3.6m -c _configtest.c -o _configtest.o
    gcc -pthread -B /home/username/anaconda3/compiler_compat -Wl,--sysroot=/ _configtest.o -Lbuild/temp.linux-x86_64-3.6 -ldl -o _configtest
    success!
    removing: _configtest.c _configtest.o _configtest
    building 'mpi4py.dl' extension
    gcc -pthread -B /home/username/anaconda3/compiler_compat -Wl,--sysroot=/ -Wsign-compare -DNDEBUG -g -fwrapv -O3 -Wall -Wstrict-prototypes -fPIC -DHAVE_DLFCN_H=1 -DHAVE_DLOPEN=1 -I/home/username/anaconda3/include/python3.6m -c src/dynload.c -o build/temp.linux-x86_64-3.6/src/dynload.o
    gcc -pthread -shared -B /home/username/anaconda3/compiler_compat -L/home/username/anaconda3/lib -Wl,-rpath=/home/username/anaconda3/lib -Wl,--no-as-needed -Wl,--sysroot=/ build/temp.linux-x86_64-3.6/src/dynload.o -Lbuild/temp.linux-x86_64-3.6 -ldl -o build/lib.linux-x86_64-3.6/mpi4py/dl.cpython-36m-x86_64-linux-gnu.so
    checking for MPI compile and link ...
    gcc -pthread -B /home/username/anaconda3/compiler_compat -Wl,--sysroot=/ -Wsign-compare -DNDEBUG -g -fwrapv -O3 -Wall -Wstrict-prototypes -fPIC -I/home/username/anaconda3/include/python3.6m -c _configtest.c -o _configtest.o
    _configtest.c:2:17: fatal error: mpi.h: No such file or directory
    compilation terminated.
    failure.
    removing: _configtest.c _configtest.o
    error: Cannot compile MPI programs. Check your configuration!!!

    Command "/home/username/anaconda3/bin/python -u -c "import setuptools, tokenize;__file__='/tmp/pip-build-8zxw1o7r/mpi4py/setup.py';f=getattr(tokenize, 'open', open)(__file__);code=f.read().replace('\r\n', '\n');f.close();exec(compile(code, __file__, 'exec'))" install --record /tmp/pip-ublkswyp-record/install-record.txt --single-version-externally-managed --compile" failed with error code 1 in /tmp/pip-build-8zxw1o7r/mpi4py/
  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 2

checkベストアンサー

+1

mpiヘッダーのパスが通ってないです。

インストール済みであれば、パスを確認してください。
そうでないのなら、インストールしてください。
http://discexuno.wp.xdomain.jp/2016/09/15/openmpiをxubuntu-16-04にインストール/
https://www.devmanuals.net/install/ubuntu/ubuntu-16-04-LTS-Xenial-Xerus/how-to-install-openmpi-bin.html

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2018/03/05 23:00

    パスを通すことで見事に動きました。ありがとうございました。

    キャンセル

0

そのパッケージでよく起こるエラーのようです。ちょっと調べると対応方法を書いたサイトもいくつかありました。
https://yoheikoga.github.io/2017/09/13/install-mpi4py-in-python36/

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 87.34%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

同じタグがついた質問を見る

閲覧数の多いLinuxの質問